
import csnd.*;

Csound               csoundInstance;
CsoundThread         csoundPerformanceThread = null;
SWIGTYPE_p_void      myvoid;
SWIGTYPE_p_CSOUND_   mycsound;
CsoundMYFLTArray     myfltarray;
double               mynums = 0.0;

float cosine;
float myfloat;

void setup ()
{
  size(200, 200);
  noStroke();
  frameRate(30);

  if ( csoundInstance == null ) 
  {
    csnd.csoundInitialize(null, null, csnd.CSOUNDINIT_NO_SIGNAL_HANDLER);
    csoundInstance = new Csound();
    myfltarray = new CsoundMYFLTArray();
    mycsound = csnd.csoundCreate(myvoid);
  }

  if ( csoundPerformanceThread != null ) 
  {
    if ( csoundPerformanceThread.isRunning() == true ) 
    {
      csoundInstance.Stop();
    }
  } 

  CsoundFile d = new CsoundFile(); 
  d.load("/home/JCH/sketchbook/CsndChnsetRotateCube/chnset3.csd");
  boolean b = d.exportForPerformance(); 
  int rc = csoundInstance.Compile("/home/JCH/sketchbook/CsndChnsetRotateCube/chnset3.csd");
  if ( rc == 0 ) 
  {
    CsoundThread  csoundPerformanceThread = new CsoundThread();
    csoundPerformanceThread.startCsound(); 
  }    
}

void draw()
{
  background(0);
  myfloat = (float) mynums;
  cosine = cos(myfloat);

  translate(width/2, height/2);
  rotate(cosine);
  rectMode(CENTER);
  fill(204, 102, 0);
  rect(0, 0, 115, 115); 
}

void drawRender1(){
  color inside = color(204, 102, 0);
  color middle = color(204, 153, 0);
  color outside = color(153, 51, 0);

  fill(outside);
  rect(0, 0, 200, 200);
  fill(middle);
  rect(40, 60, 120, 120);
  fill(inside);
  rect(60, 90, 80, 80); 
}

void drawRender2(){
  color inside2 = color(20, 102, 0);
  color middle2 = color(20, 153, 0);
  color outside2 = color(15, 51, 0);

  fill(outside2);
  rect(0, 0, 200, 200);
  fill(middle2);
  rect(40, 60, 120, 120);
  fill(inside2);
  rect(60, 90, 80, 80);
}


class CsoundThread extends Thread 
{
  private boolean running = false;
  int x = 0;

  public void startCsound() 
  {
    running = true;
    start();
  }

  public void run() 
  {
    try {
      int myoutputch = csndConstants.CSOUND_OUTPUT_CHANNEL;
      int mycontch = csndConstants.CSOUND_CONTROL_CHANNEL;
      SWIGTYPE_p_p_double myptr = myfltarray.GetPtr();

      while (csoundInstance.PerformKsmps() == 0) {
        if (csnd.csoundGetChannelPtr(mycsound, myptr, "envel", mycontch | myoutputch) == 0)  
        {
          mynums = csoundInstance.GetChannel("envel");
        } 
      } 
    }
    catch (Exception e) {
    }
    csoundInstance.Stop();
    csoundInstance.Reset();
  }

  public synchronized boolean isRunning() {
    return running;
  }
  public synchronized void  setRunning( boolean running ) {
    this.running = running;
  }
}






