/**
 * dowload OscP5 library from www.sojamo.de/libraries/oscP5/
 * This is a modified example from oscP5plug by andreas schlegel
 * See File/examples/Libraries/oscP5/oscp5plug
 * 
 */

import oscP5.*;
import netP5.*;

OscP5 oscP5;
NetAddress myRemoteLocation;

int[] x;
float[] y;
String[] z;
int myframes = 0;

void setup() {
  size(100,100);
  frameRate(25);
  
  x = new int[101];
  y = new float[101];
  z = new String[101];
  
  //assign port number here, ex. 7770
  oscP5 = new OscP5(this,7770);
  myRemoteLocation = new NetAddress("127.0.0.1",7770);
  oscP5.plug(this,"test","/test");
}


public void test(int theA, float theB, String theC) {
  println("### plug event method. received a message /test.");
  println(" 2 values received: "+theA+", "+theB+", "+theC);  
}


void draw() {
  background(0, 255, 0);

   
  if (frameCount > (100)) {
    drawRender();
  }    

}

void drawRender(){
  background(255, 204, 0);
  
  myframes = myframes + 1;
    println("Frame "+myframes+"- KVAL1 = "+x[myframes]+"   KVAL2 = "+y[myframes]+",  STRING = "+z[myframes]);

  if (myframes > (99)) {
    background(255, 0, 0);
    exit();
  } 
}


void oscEvent(OscMessage theOscMessage) {
  if(theOscMessage.isPlugged()==false) {
  x[frameCount] = theOscMessage.get(0).intValue();
  y[frameCount] = theOscMessage.get(1).floatValue();
  z[frameCount] = theOscMessage.get(2).stringValue();
}
}
